import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import netscape.security.*;

public class WordCount extends Applet {
  public void init() {
    setLayout (new GridLayout (3, 2));
    add(new Label ("URL:", Label.RIGHT));
    final TextField urlString = new TextField();
    add (urlString);
    add(new Label ("Count:", Label.RIGHT));
    final TextField count = new TextField();
    count.setEditable(false);
    add (count);
    add (new Panel());
    Button b = new Button ("Fetch");
    add (b);
    b.addActionListener (new ActionListener() {
      public void actionPerformed (ActionEvent e) {
        int theCount = getCount (urlString.getText());
        count.setText ("" + theCount);
      }
    });
  }
  private int getCount (String urlString) {
    int count = 0;
    if ((urlString != null) && (urlString.length() != 0)) {
      try {
        // Set Wait Cursor
        setCursor (Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        // Enable connections to anywhere on network
        PrivilegeManager.enablePrivilege ("UniversalConnect");
        URL url = new URL (urlString);
        URLConnection con = url.openConnection();
        InputStreamReader isr = 
          new InputStreamReader (con.getInputStream());
        BufferedReader br = new BufferedReader (isr);
        StreamTokenizer input = new StreamTokenizer (br);
        int tok;
        while ((tok = input.nextToken()) != StreamTokenizer.TT_EOF) {
          if (tok == StreamTokenizer.TT_WORD) {
//            System.out.println ("Word found: " + input.sval);
            count++;
          }
        }
        // Disable connections
        PrivilegeManager.revertPrivilege ("UniversalConnect");
      } catch (ForbiddenTargetException e) {
        popupMessage("User denied access to URL: " + urlString);
      } catch (MalformedURLException e) {
        popupMessage("Bad URL string: " + urlString);
      } catch (IOException e) {
        popupMessage("I/O Exception counting words");
      } finally {
        setCursor (Cursor.getDefaultCursor());
      }
    }
    return count;
  }
  private void popupMessage (String s) {
    // Create Dialogs w/o applet warning message
    PrivilegeManager.enablePrivilege ("UniversalTopLevelWindow");
    final Dialog d = new Dialog (getTopLevelParent());
    // Put message back
    PrivilegeManager.revertPrivilege ("UniversalTopLevelWindow");
    d.add (new Label (s, Label.CENTER), BorderLayout.CENTER);
    Button b = new Button ("Close");
    d.add (b, BorderLayout.SOUTH);
    b.addActionListener (new ActionListener () {
      public void actionPerformed (ActionEvent e) {
        d.setVisible(false);
        d.dispose();
      }
    });
    d.pack();
    d.show();
  }
  private Frame getTopLevelParent() {
    Component c = this;
    while (c.getParent() != null)
      c = c.getParent();
    if (c instanceof Frame)
      return (Frame)c;
    else
      return null;
  }
}
