import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

class PropLabel extends Label implements PropertyChangeListener {
  public void propertyChange(PropertyChangeEvent e) {
    if (e.getPropertyName().equals("message")) {
      setText((String)e.getNewValue());
    }
  };
}

public class CentralPerkTester extends Applet implements PerkListener {
  public void init () {
    setLayout (new BorderLayout());
    final CentralPerk cp = new CentralPerk();
    add (cp, BorderLayout.CENTER);
    PropLabel l = new PropLabel();
    add (l, BorderLayout.NORTH);
    cp.addPropertyChangeListener (l);
    cp.addPerkListener (this);
    Panel p = new Panel (new GridLayout(0, 2));
    Label tl = new Label ("Enter New Text:");
    p.add (tl);
    TextField tf1 = new TextField("", 20);
    p.add (tf1);
    tf1.addActionListener ( new ActionListener() {
      public void actionPerformed (ActionEvent e) {
        cp.setMessage (e.getActionCommand());
      }
    });
    Label t2 = new Label ("Enter New Rate:");
    p.add (t2);
    TextField tf2 = new TextField();
    p.add (tf2);
    tf2.addActionListener ( new ActionListener() {
      public void actionPerformed (ActionEvent e) {
        try {
          cp.setMovingRate (Integer.parseInt(e.getActionCommand()));
        } catch (NumberFormatException ne) {
          cp.setMovingRate (cp.getMovingRate());
        }
      }
    });
    add (p, BorderLayout.SOUTH);
  }
  public void startedPerking (PerkEvent e) {
    System.out.println ("Perked message: " + e.getMessage());
  }
}
