/**** ProgressAppletTest.java ****/

/*
<applet code="ProgressAppletTest" width=450 height=150></applet>
*/

//
// ProgressAppletTest tests a Progress bean under load.  Thread
// management is implemented in the ProgressThread class.
//

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import progress.*;

public class ProgressAppletTest extends Applet implements ActionListener {
  Progress p;
  ProgressThread pt;
  Button startProgress, stopProgress, setProgress;
  TextField tf;

  public void init() {
    setLayout(new BorderLayout());
    Panel panel = new Panel();
    panel.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 15));
    panel.add(p = new Progress());
    panel.add(tf = new TextField(5));
    tf.addActionListener(this);
    panel.add(setProgress = new Button(" Set Progress "));
    setProgress.addActionListener(this);
    add(panel, BorderLayout.NORTH);
    Panel panel2 = new Panel();
    panel2.setLayout(new FlowLayout(FlowLayout.CENTER, 30, 10));
    panel2.add(startProgress = new Button(" Start Progress "));
    startProgress.addActionListener(this);
    panel2.add(stopProgress = new Button(" Stop Progress "));
    stopProgress.addActionListener(this);
    add(panel2, BorderLayout.SOUTH);
    pt = null;
  }

  public void start() {
    if (pt != null)
      p.setPercent(0);
  }

  public void stop() {
    if (pt != null)
      pt.shutdown();
  }

  public void actionPerformed(ActionEvent event) {
    Object source = event.getSource();
    if (source == startProgress) {
      if (pt == null) {
        pt = new ProgressThread(p, 5, 500);
        pt.start();
      }
    }
    else if (source == stopProgress) {
      if (pt != null) {
        pt.shutdown();
        pt = null;
      }
    }
    else if (source == tf || source == setProgress) {
      p.setPercent(Integer.parseInt(tf.getText()));
    }
  }
}


class ProgressThread extends Thread {
  Progress progress;
  int increment = 1;
  int delay = 100;
  boolean terminate;

  ProgressThread(Progress progress, int increment, int delay) {
    this.progress = progress;
    this.increment = increment;
    this.delay = delay;
    terminate = false;
  }

  public void run() {
    int percent = 0;
    while(!terminate) {
      progress.setPercent(percent);
      try {
        sleep(delay);
      }
      catch (InterruptedException e) {
        return;
      }
      percent = update_percent(percent, increment);
    }
  }

  public void shutdown() {
    terminate = true;
  }

  private int update_percent(int percent, int increment) {
    percent += increment;
    if (percent > 100)
      percent = 0;
    return percent;
  }
}
