/**** SmileyAppletTest.java ****/

/*
<applet code="SmileyAppletTest" width=450 height=330></applet>
*/

//
// SmileyAppletTest tests a Smiley bean.
//

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.beans.*;
import smiley.*;

public class SmileyAppletTest extends Applet
    implements ActionListener, SmileyListener,
      PropertyChangeListener {
  Smiley s;
  Button changeMood;
  TextField smileySize, currentMood;
  Panel sizePanel, smileyPanel, moodPanel;
  public void init() {
    setLayout(new BorderLayout());
    sizePanel = new Panel();
    sizePanel.add(new Label("Size: "));
    sizePanel.add(smileySize = new TextField(5));
    add(sizePanel, BorderLayout.NORTH);
    smileyPanel = new Panel();
    smileyPanel.add(s = new Smiley());
    add(smileyPanel, BorderLayout.CENTER);
    moodPanel = new Panel();
    moodPanel.add(currentMood = new TextField(20));
    currentMood.setEditable(false);
    moodPanel.add(changeMood = new Button("Change Mood"));
    add(moodPanel, BorderLayout.SOUTH);
    smileySize.addActionListener(this);
    s.addSmileyListener(this);
    s.addPropertyChangeListener(this);
    changeMood.addActionListener(this);
    s.setMood(Smiley.HAPPY); // force update to text field
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == changeMood) {
      if (s.getMood() == Smiley.HAPPY)
        s.setMood(Smiley.SAD);
      else
        s.setMood(Smiley.HAPPY);
    }
    else if (e.getSource() == smileySize) {
      try {
        int i = Integer.parseInt(smileySize.getText());
        s.setDiameter(i);
        smileyPanel.validate();
      }
      catch (NumberFormatException nfe) {}
    }
  }

  public void moodChanged(SmileyEvent e) {
    String str = (e.getMood() == Smiley.HAPPY) ? "happy" : "sad";
    currentMood.setText("Smiley is " + str + ".");
  }

  public void propertyChange(PropertyChangeEvent e) {
    System.out.println("The '" + e.getPropertyName() +
      "' property changed value:");
    System.out.println("Old value:  " + e.getOldValue());
    System.out.println("New value:  " + e.getNewValue());
    System.out.println("Component width:  " + s.getSize().width);
    System.out.println("Component height:  " + s.getSize().height);
  }
}