/**** StickFigureAppletTest.java ****/

/*
<applet code="StickFigureAppletTest" width=300 height=200></applet>
*/

//
// StickFigureAppletTest tests a StickFigure bean.
//

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.beans.*;
import stickfigure.*;

public class StickFigureAppletTest extends Applet implements
    ItemListener, StickFigureListener, PropertyChangeListener {
  StickFigure s;
  Checkbox neck, leftArm, rightArm, trunk, leftLeg, rightLeg, sunburn;
  Panel cmdPanel;

  public void init() {
    setLayout(new BorderLayout());
    add(s = new StickFigure(), BorderLayout.CENTER);
    cmdPanel = new Panel(new GridLayout(7, 1));
    cmdPanel.add(neck = new Checkbox("Neck", s.getNeck()));
    cmdPanel.add(leftArm = new Checkbox("Left Arm", s.getLeftArm()));
    cmdPanel.add(rightArm = new Checkbox("Right Arm", s.getRightArm()));
    cmdPanel.add(trunk = new Checkbox("Trunk", s.getTrunk()));
    cmdPanel.add(leftLeg = new Checkbox("Left Leg", s.getLeftLeg()));
    cmdPanel.add(rightLeg = new Checkbox("Right Leg", s.getRightLeg()));
    cmdPanel.add(sunburn = new Checkbox("Sunburned", s.isSunburned()));
    add(cmdPanel, BorderLayout.WEST);
    s.addStickFigureListener(this);
    s.addPropertyChangeListener(this);
    neck.addItemListener(this);
    leftArm.addItemListener(this);
    rightArm.addItemListener(this);
    trunk.addItemListener(this);
    leftLeg.addItemListener(this);
    rightLeg.addItemListener(this);
    sunburn.addItemListener(this);
  }

  public void itemStateChanged(ItemEvent e) {
    Checkbox c = (Checkbox) e.getSource();
    if (c == neck)
      s.setNeck(c.getState());
    else if (c == leftArm)
      s.setLeftArm(c.getState());
    else if (c == rightArm)
      s.setRightArm(c.getState());
    else if (c == trunk)
      s.setTrunk(c.getState());
    else if (c == leftLeg)
      s.setLeftLeg(c.getState());
    else if (c == rightLeg)
      s.setRightLeg(c.getState());
    else if (c == sunburn)
      s.setSunburned(c.getState());
  }

  public void stickFigureChanged(StickFigureEvent e) {
    System.out.println("StickFigure event...");
  }

  public void propertyChange(PropertyChangeEvent e) {
    System.out.println("The '" + e.getPropertyName() +
      "' property changed value:");
    System.out.println("Old value:  " + e.getOldValue());
    System.out.println("New value:  " + e.getNewValue());
  }
}