package hire;

import java.beans.*;

public class DepartmentEditor 
    extends PropertyEditorSupport {

  protected int dept;

  public void setValue(Object o) {
    dept = ((Integer)o).intValue();
    firePropertyChange();
  }

  public Object getValue() {
    return (new Integer(dept));
  }

  public String getAsText() {
    switch (dept) {
      case Dept.MARKETING:
        return Dept.MARKETING_STR;
      case Dept.TRAINING:
        return Dept.TRAINING_STR;
      case Dept.SALES:
        return Dept.SALES_STR;
      case Dept.RESEARCH:
        return Dept.RESEARCH_STR;
      default:
        return Dept.UNASSIGNED_STR;
    }
  }

  public void setAsText(String s) 
      throws IllegalArgumentException {
    if (s.equalsIgnoreCase(Dept.MARKETING_STR))
      dept = Dept.MARKETING;
    else if (s.equalsIgnoreCase(Dept.TRAINING_STR))
      dept = Dept.TRAINING;
    else if (s.equalsIgnoreCase(Dept.SALES_STR))
      dept = Dept.SALES;
    else if (s.equalsIgnoreCase(Dept.RESEARCH_STR))
      dept = Dept.RESEARCH;
    else
      dept = Dept.UNASSIGNED;
    firePropertyChange();
  }

  public String[] getTags() {
    return new String[] {
      Dept.MARKETING_STR, Dept.TRAINING_STR,
      Dept.SALES_STR, Dept.RESEARCH_STR,
      Dept.UNASSIGNED_STR
    };
  }
}