package hire;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;

public class HireCustomizer extends Panel
    implements Customizer, ActionListener, ItemListener {

  private Hire hireObject;
  private TextField salary;
  private Choice dept;
  private PropertyChangeSupport support;

  public HireCustomizer() {
    support = new PropertyChangeSupport(this);
    setLayout(new GridLayout(2, 1));
    CustomizerPanel p1 = new CustomizerPanel();
    p1.setLayout(new BorderLayout());
    add(p1);
    p1.add(new Label("Salary:"), BorderLayout.WEST);
    p1.add(salary = new TextField(20), BorderLayout.EAST);
    salary.addActionListener(this);
    CustomizerPanel p2 = new CustomizerPanel();
    p2.setLayout(new BorderLayout());
    add(p2);
    p2.add(new Label("Department:"), BorderLayout.WEST);
    p2.add(dept = new Choice(), BorderLayout.EAST);
    dept.addItemListener(this);
    dept.add(Dept.MARKETING_STR);
    dept.add(Dept.TRAINING_STR);
    dept.add(Dept.SALES_STR);
    dept.add(Dept.RESEARCH_STR);
    dept.add(Dept.UNASSIGNED_STR);
  }

  public void setObject(Object obj) {
    hireObject = (Hire) obj;
    salary.setText(String.valueOf(hireObject.getSalary()));
    selectChoiceItem();
  }

  public void actionPerformed(ActionEvent e) {
    Object source = e.getSource();
    if (source == salary) {
      String text = salary.getText();
      try {
        hireObject.setSalary(
          (new Float(text)).floatValue());
      } catch (NumberFormatException ex) {
        salary.setText(
          String.valueOf(hireObject.getSalary()));
      }
      support.firePropertyChange("salary", null, null);
    }
  }

  public void itemStateChanged(ItemEvent e) {
    Choice c = (Choice) e.getSource();
    String label = (String) c.getSelectedObjects()[0];
    if (label == null)
      return;
    if (label.equalsIgnoreCase(Dept.MARKETING_STR))
      hireObject.setDepartment(Dept.MARKETING);
    else if (label.equalsIgnoreCase(Dept.TRAINING_STR))
      hireObject.setDepartment(Dept.TRAINING);
    else if (label.equalsIgnoreCase(Dept.SALES_STR))
      hireObject.setDepartment(Dept.SALES);
    else if (label.equalsIgnoreCase(Dept.RESEARCH_STR))
      hireObject.setDepartment(Dept.RESEARCH);
    else
      hireObject.setDepartment(Dept.UNASSIGNED);
    support.firePropertyChange("department", null, null);
  }

  public void addPropertyChangeListener(
      PropertyChangeListener l) {
    support.addPropertyChangeListener(l);
  }

  public void removePropertyChangeListener(
      PropertyChangeListener l) {
    support.removePropertyChangeListener(l);
  }

  private void selectChoiceItem() {
    if (hireObject.getDepartment() == Dept.MARKETING)
      dept.select(Dept.MARKETING_STR);
    else if (hireObject.getDepartment() == Dept.TRAINING)
      dept.select(Dept.TRAINING_STR);
    else if (hireObject.getDepartment() == Dept.SALES)
      dept.select(Dept.SALES_STR);
    else if (hireObject.getDepartment() == Dept.RESEARCH)
      dept.select(Dept.RESEARCH_STR);
    else
      dept.select(Dept.UNASSIGNED_STR);
  }
}

class CustomizerPanel extends Panel {
  public Insets getInsets() {
    return new Insets(5, 5, 5, 5);
  }
}