/**** Progress.java ****/



//

// Progress implements an extremely simplistic progress bar with

// minimal bean functionality--this is a minimal-code demo program.

//



package progress;



import java.awt.*;

import java.util.*;



public class Progress extends Canvas {

  private int percent = 0, oldPercent = 0;

  Vector targets = new Vector();



  public Progress() {

    setForeground(Color.red);

    setBackground(Color.gray);

  }



  public synchronized void setPercent(int p) {

    if (p < 0 || p > 100) {

      percent = 0;

    }

    else {

      oldPercent = percent;

      percent = p;

    }

    repaint();

    notifyTargets();

  }



  public int getPercent() {

    return percent;

  }



  public void incPercent() {

    setPercent(getPercent() + 10);

  }



  public void incPercent(int p) {

    setPercent(getPercent() + p);

  }



  public synchronized void addProgressListener(ProgressListener p) {

    targets.addElement(p);

  }



  public synchronized void removeProgressListener(ProgressListener p) {

    targets.removeElement(p);

  }



  public void update(Graphics g) {

    paint(g);

  }



/*********************************************************

  public void paint(Graphics g) {

    int w = getSize().width;

    int h = getSize().height;

    g.setColor(getBackground());

    g.fillRect(0, 0, w, h);

    g.setColor(getForeground());

    g.fillRect(0, 0, getPercentInPixels(percent), h);

  }

***********************************************************/



  public void paint(Graphics g) {

    int w = getSize().width;

    int h = getSize().height;

    int oldWidth = getPercentInPixels(oldPercent);

    int newWidth = getPercentInPixels(percent);

    if (newWidth > oldWidth) {

      g.fillRect(0, 0, newWidth, h);

    }

    else {

      g.setColor(getBackground());

      g.fillRect(newWidth, 0, w - newWidth, h);

      g.setColor(getForeground());

    }

  }



  public Dimension getMinimumSize() {

    return new Dimension(100, 20);

  }



  public Dimension getPreferredSize() {

    return new Dimension(200, 30);

  }



  private synchronized void notifyTargets() {

    Vector temp;

    ProgressEvent pe = new ProgressEvent(this, percent);

    synchronized (this) {

      temp = (Vector) targets.clone();

    }

    for (int i = 0; i < temp.size(); i++) {

      ProgressListener p = (ProgressListener) temp.elementAt(i);

      p.progressMade(pe);

    }

  }



  private int getPercentInPixels(int percent) {

    return (int) ((float) getSize().width * (float) percent / (float) 100);

  }

}

