package smiley;

import java.beans.*;

public class MoodEditor 
    extends PropertyEditorSupport {

  protected int mood;

  public void setValue(Object o) {
    mood = ((Integer)o).intValue();
    firePropertyChange();
  }

  public Object getValue() {
    return new Integer(mood);
  }

  public String getAsText() {
    switch (mood) {
      case Smiley.HAPPY:
        return Smiley.HAPPY_STR;
      case Smiley.SAD:
        return Smiley.SAD_STR;
      default:
        return Smiley.HAPPY_STR;
    }
  }

  public void setAsText(String s) 
      throws IllegalArgumentException {
    if (s.equalsIgnoreCase(Smiley.HAPPY_STR))
      mood = Smiley.HAPPY;
    else if (s.equalsIgnoreCase(Smiley.SAD_STR))
      mood = Smiley.SAD;
    else
      mood = Smiley.HAPPY;
    firePropertyChange();
  }

  public String[] getTags() {
    return new String[] {Smiley.HAPPY_STR, Smiley.SAD_STR};
  }
}