package smiley;

import java.beans.*;

public class SmileyBeanInfo
    extends SimpleBeanInfo {

  public BeanDescriptor getBeanDescriptor() {
    return new
      BeanDescriptor(Smiley.class, SmileyCustomizer.class);
  }

  public PropertyDescriptor[]
      getPropertyDescriptors() {
    try {
      PropertyDescriptor pd1 = new
        PropertyDescriptor("diameter", Smiley.class);
      pd1.setBound(true);
      pd1.setPropertyEditorClass(DiameterEditor.class);
      PropertyDescriptor pd2 = new
        PropertyDescriptor("mood", Smiley.class);
      pd2.setBound(true);
      pd2.setPropertyEditorClass(MoodEditor.class);
      return new PropertyDescriptor[] {pd1, pd2};
    } catch (Exception e) {
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind) {
    if (iconKind == ICON_COLOR_16x16 || iconKind == ICON_MONO_16x16)
      return loadImage("smiley16x16.gif");
    else
      return loadImage("smiley32x32.gif");
  }
}