package smiley;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;

public class SmileyCustomizer extends Panel
    implements Customizer, ActionListener, ItemListener {

  private Smiley smileyObject;
  private TextField diameter;
  CheckboxGroup mood;
  Checkbox happy, sad;
  private PropertyChangeSupport support;

  public SmileyCustomizer() {
    support = new PropertyChangeSupport(this);
    setLayout(new GridLayout(2, 1));
    Panel p1 = new Panel(new BorderLayout());
    add(p1);
    p1.add(new Label("Diameter:"), BorderLayout.WEST);
    p1.add(diameter = new TextField(20), BorderLayout.EAST);
    diameter.addActionListener(this);
    Panel p2 = new Panel(new BorderLayout());
    add(p2);
    p2.add(new Label("Mood:"), BorderLayout.WEST);
    Panel moodPanel;
    p2.add(moodPanel = new Panel(), BorderLayout.EAST);
    mood = new CheckboxGroup();
    moodPanel.add(happy =
      new Checkbox(Smiley.HAPPY_STR, true, mood));
    moodPanel.add(sad =
      new Checkbox(Smiley.SAD_STR, false, mood));
    happy.addItemListener(this);
    sad.addItemListener(this);
  }

  public void setObject(Object obj) {
    smileyObject = (Smiley) obj;
    diameter.setText(String.valueOf(smileyObject.getDiameter()));
    if (smileyObject.getMood() == Smiley.HAPPY)
      mood.setSelectedCheckbox(happy);
    else if (smileyObject.getMood() == Smiley.SAD)
      mood.setSelectedCheckbox(sad);
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == diameter) {
      String text = diameter.getText();
      try {
        smileyObject.setDiameter(
          (new Integer(text)).intValue());
      } catch (NumberFormatException ex) {
        diameter.setText(
          String.valueOf(smileyObject.getDiameter()));
      }
      support.firePropertyChange("diameter", null, null);
    }
  }

  public void itemStateChanged(ItemEvent e) {
    Checkbox cb = (Checkbox) e.getSource();
    if (cb == happy)
      smileyObject.setMood(Smiley.HAPPY);
    else if (cb == sad)
      smileyObject.setMood(Smiley.SAD);
    support.firePropertyChange("mood", null, null);
  }    

  public void addPropertyChangeListener(
      PropertyChangeListener l) {
    support.addPropertyChangeListener(l);
  }

  public void removePropertyChangeListener(
      PropertyChangeListener l) {
    support.removePropertyChangeListener(l);
  }
}