/**** SuppliersAndPartsInsertRecords.java ****/

import java.sql.*;

public class SuppliersAndPartsInsertRecords {
  public static void main(String[] args) {
    if (usageOnly(args))
      return;
    String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
    if (args.length > 0)
      driver = args[0];
    String url = "jdbc:odbc:SuppliersAndParts";
    if (args.length > 1)
      url = args[1];
    try {
      Class.forName(driver).newInstance();
      Connection con = DriverManager.getConnection(url);
      System.out.println("Connected to: " + url);
      Statement stmt = con.createStatement();

      stmt.executeUpdate("insert into S values ('S1', 'Smith', 20, 'London')");
      stmt.executeUpdate("insert into S values ('S2', 'Jones', 10, 'Paris')");
      stmt.executeUpdate("insert into S values ('S3', 'Blake', 30, 'Paris')");
      stmt.executeUpdate("insert into S values ('S4', 'Clark', 20, 'London')");
      stmt.executeUpdate("insert into S values ('S5', 'Adams', 30, 'Athens')");

      stmt.executeUpdate("insert into P values ('P1', 'Nut', 'Red', 12, 'London')");
      stmt.executeUpdate("insert into P values ('P2', 'Bolt', 'Green', 17, 'Paris')");
      stmt.executeUpdate("insert into P values ('P3', 'Screw', 'Blue', 17, 'Rome')");
      stmt.executeUpdate("insert into P values ('P4', 'Screw', 'Red', 14, 'London')");
      stmt.executeUpdate("insert into P values ('P5', 'Cam', 'Blue', 12, 'Paris')");
      stmt.executeUpdate("insert into P values ('P6', 'Cog', 'Red', 19, 'London')");

      stmt.executeUpdate("insert into J values ('J1', 'Sorter', 'Paris')");
      stmt.executeUpdate("insert into J values ('J2', 'Punch', 'Rome')");
      stmt.executeUpdate("insert into J values ('J3', 'Reader', 'Athens')");
      stmt.executeUpdate("insert into J values ('J4', 'Console', 'Athens')");
      stmt.executeUpdate("insert into J values ('J5', 'Collator', 'London')");
      stmt.executeUpdate("insert into J values ('J6', 'Terminal', 'Oslo')");
      stmt.executeUpdate("insert into J values ('J7', 'Tape', 'London')");

      stmt.executeUpdate("insert into SP values ('S1', 'P1', 300)");
      stmt.executeUpdate("insert into SP values ('S1', 'P2', 200)");
      stmt.executeUpdate("insert into SP values ('S1', 'P3', 400)");
      stmt.executeUpdate("insert into SP values ('S1', 'P4', 200)");
      stmt.executeUpdate("insert into SP values ('S1', 'P5', 100)");
      stmt.executeUpdate("insert into SP values ('S1', 'P6', 100)");
      stmt.executeUpdate("insert into SP values ('S2', 'P1', 300)");
      stmt.executeUpdate("insert into SP values ('S2', 'P2', 400)");
      stmt.executeUpdate("insert into SP values ('S3', 'P2', 200)");
      stmt.executeUpdate("insert into SP values ('S4', 'P2', 200)");
      stmt.executeUpdate("insert into SP values ('S4', 'P4', 300)");
      stmt.executeUpdate("insert into SP values ('S4', 'P5', 400)");

      stmt.executeUpdate("insert into SPJ values ('S1', 'P1', 'J1', 200)");
      stmt.executeUpdate("insert into SPJ values ('S1', 'P1', 'J4', 700)");
      stmt.executeUpdate("insert into SPJ values ('S2', 'P3', 'J1', 400)");
      stmt.executeUpdate("insert into SPJ values ('S2', 'P3', 'J2', 200)");
      stmt.executeUpdate("insert into SPJ values ('S2', 'P3', 'J3', 200)");
      stmt.executeUpdate("insert into SPJ values ('S2', 'P3', 'J4', 500)");
      stmt.executeUpdate("insert into SPJ values ('S2', 'P3', 'J5', 600)");
      stmt.executeUpdate("insert into SPJ values ('S2', 'P3', 'J6', 400)");
      stmt.executeUpdate("insert into SPJ values ('S2', 'P3', 'J7', 800)");
      stmt.executeUpdate("insert into SPJ values ('S2', 'P5', 'J2', 100)");
      stmt.executeUpdate("insert into SPJ values ('S3', 'P3', 'J1', 200)");
      stmt.executeUpdate("insert into SPJ values ('S3', 'P4', 'J2', 500)");
      stmt.executeUpdate("insert into SPJ values ('S4', 'P6', 'J3', 300)");
      stmt.executeUpdate("insert into SPJ values ('S4', 'P6', 'J7', 300)");
      stmt.executeUpdate("insert into SPJ values ('S5', 'P2', 'J2', 200)");
      stmt.executeUpdate("insert into SPJ values ('S5', 'P2', 'J4', 100)");
      stmt.executeUpdate("insert into SPJ values ('S5', 'P5', 'J5', 500)");
      stmt.executeUpdate("insert into SPJ values ('S5', 'P5', 'J7', 100)");
      stmt.executeUpdate("insert into SPJ values ('S5', 'P6', 'J2', 200)");
      stmt.executeUpdate("insert into SPJ values ('S5', 'P1', 'J4', 100)");
      stmt.executeUpdate("insert into SPJ values ('S5', 'P3', 'J4', 200)");
      stmt.executeUpdate("insert into SPJ values ('S5', 'P4', 'J4', 800)");
      stmt.executeUpdate("insert into SPJ values ('S5', 'P5', 'J4', 400)");
      stmt.executeUpdate("insert into SPJ values ('S5', 'P6', 'J4', 500)");
      stmt.close();
      con.close();
    }
    catch (SQLException ex) {
      System.out.println("\nSQLException...\n");
      while (ex != null) {
        System.out.println("SQLState: " + ex.getSQLState());
        System.out.println("Message:  " + ex.getMessage());
        System.out.println("Vendor:   " + ex.getErrorCode());
        ex = ex.getNextException();
        System.out.println("");
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private static boolean usageOnly(String[] args) {
    if (args.length > 0) {
      if (args[0].equalsIgnoreCase("-help") ||
          args[0].equalsIgnoreCase("-h") ||
          args[0].equalsIgnoreCase("-usage") ||
          args.length > 2)
        System.out.println(
          "Usage: java SuppliersAndPartsInsertRecords" +
          " [<driver>] [<url>]");
      return true;
    }
    else
      return false;
  }
} // SuppliersAndPartsInsertRecords class //