package flexlabel;

import java.beans.*;

public class AlignmentEditor 
    extends PropertyEditorSupport {

  private int alignment;

  public void setValue(Object o) {
    alignment = ((Integer)o).intValue();
    firePropertyChange();
  }

  public Object getValue() {
    return new Integer(alignment);
  }

  public String getAsText() {
    switch (alignment) {
      case FlexLabel.ALIGN_LEFT:
        return FlexLabel.ALIGN_LEFT_STR;
      case FlexLabel.ALIGN_RIGHT:
        return FlexLabel.ALIGN_RIGHT_STR;
      case FlexLabel.ALIGN_CENTER:
        return FlexLabel.ALIGN_CENTER_STR;
      default:
        return FlexLabel.ALIGN_LEFT_STR;
    }
  }

  public void setAsText(String s) 
      throws IllegalArgumentException {
    if (s.equalsIgnoreCase(FlexLabel.ALIGN_LEFT_STR))
      alignment = FlexLabel.ALIGN_LEFT;
    else if (s.equalsIgnoreCase(FlexLabel.ALIGN_RIGHT_STR))
      alignment = FlexLabel.ALIGN_RIGHT;
    else if (s.equalsIgnoreCase(FlexLabel.ALIGN_CENTER_STR))
      alignment = FlexLabel.ALIGN_CENTER;
    else
      alignment = FlexLabel.ALIGN_LEFT;
    firePropertyChange();
  }

  public String[] getTags() {
    return new String[] {
      FlexLabel.ALIGN_LEFT_STR,
      FlexLabel.ALIGN_CENTER_STR,
      FlexLabel.ALIGN_RIGHT_STR};
  }
}