package flexlabel;

import java.beans.*;

public class FlexLabelBeanInfo
    extends SimpleBeanInfo {

  public BeanDescriptor getBeanDescriptor() {
    return new
      BeanDescriptor(FlexLabel.class, FlexLabelCustomizer.class);
  }

  public PropertyDescriptor[]
      getPropertyDescriptors() {
    try {
      PropertyDescriptor pd1 = new
        PropertyDescriptor("label", FlexLabel.class);
      pd1.setPropertyEditorClass(LabelEditor.class);
      PropertyDescriptor pd2 = new
        PropertyDescriptor("imageFile", FlexLabel.class);
      PropertyDescriptor pd3 = new
        PropertyDescriptor("alignment", FlexLabel.class);
      pd3.setPropertyEditorClass(AlignmentEditor.class);
      PropertyDescriptor pd4 = new
        PropertyDescriptor("imagePosition", FlexLabel.class);
      pd4.setPropertyEditorClass(ImagePositionEditor.class);
      PropertyDescriptor pd5 = new
        PropertyDescriptor("horizontalSpace", FlexLabel.class);
      PropertyDescriptor pd6 = new
        PropertyDescriptor("verticalSpace", FlexLabel.class);
      PropertyDescriptor pd7 = new
        PropertyDescriptor("foreground", FlexLabel.class);
      PropertyDescriptor pd8 = new
        PropertyDescriptor("background", FlexLabel.class);
      PropertyDescriptor pd9 = new
        PropertyDescriptor("font", FlexLabel.class);
      return new PropertyDescriptor[] {
        pd1, pd2, pd3, pd4, pd5, pd6, pd7, pd8, pd9
      };
    } catch (Exception e) {
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind) {
    if (iconKind == ICON_COLOR_16x16 || iconKind == ICON_MONO_16x16)
      return loadImage("flexlabel16x16.gif");
    else
      return loadImage("flexlabel32x32.gif");
  }

}