import sock.ClientSocket;
import java.io.*;

//
// your test program will probably differ significantly ...
//

public class TestConnect {
  public static void main(String[] args) {
    if (usageOnly(args))
      System.exit(0);
    ClientSocket client = new ClientSocket();
    String host = "127.0.0.1";
    int port = 2001;
    if (args.length > 0)
      host = args[0];
    if (args.length > 1)
      port = Integer.parseInt(args[1]);
    client.setPort(port);
    client.setMachine(host);
    try {
      client.connect();
      if (port == 7) { // echo server
        client.writeln("hello");
        System.out.println("read back: " + client.readln());
      }
      else if (port == 13) { // daytime server
        System.out.println("time: " + client.readln());
      }
    }
    catch (IOException e) {
      System.err.println(e.getMessage());
    }
  }

  private static boolean usageOnly(String args[]) {
    if (args.length == 1 &&
        (args[0].equalsIgnoreCase("-usage") ||
        args[0].equalsIgnoreCase("-help") ||
        args[0].equalsIgnoreCase("-h"))) {
      System.out.println("Usage:  java TestConnect [<host>] [<port>]");
      return true;
    }
    else
      return false;
  }
}
