// Copyright MageLang Institute; Version $Id: //depot/main/src/edu/modules/Beans/magercises/SocketBean/Solution/TestConnect.java#3 $

import sock.ClientSocket;
import java.io.*;

public class TestConnect {
  public static void main(String[] args) {
    if (usageOnly(args))
      System.exit(0);
    ClientSocket client = new ClientSocket();
    String host = "127.0.0.1";
    int port = 2001;
    if (args.length > 0)
      host = args[0];
    if (args.length > 1)
      port = Integer.parseInt(args[1]);
    client.setPort(port);
    client.setMachine(host);
    try {
      client.connect();
      if (port == 13) { // daytime server
        System.out.println("time: " + client.readln());
      }
      else { // assume echo server
        client.writeln("hello");
        System.out.println("read back: " + client.readln());
      }
    }
    catch (IOException e) {
      System.err.println(e.getMessage());
    }
  }

  private static boolean usageOnly(String args[]) {
    if (args.length == 1 &&
        (args[0].equalsIgnoreCase("-usage") ||
        args[0].equalsIgnoreCase("-help") ||
        args[0].equalsIgnoreCase("-h"))) {
      System.out.println("Usage:  java TestConnect [<host>] [<port>]");
      System.out.println("  The default host is 127.0.0.1.");
      System.out.println("  The default port is 2001.");
      return true;
    }
    else
      return false;
  }
}
