import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;
import Beans.*;

public class BonusServlet extends HttpServlet {
  CalcHome homecalc;

  public void init(ServletConfig config) throws ServletException{

//Look up home interface
   try {
     InitialContext ctx = new InitialContext();
     Object objref = ctx.lookup("calcs");
     homecalc = (CalcHome)PortableRemoteObject.narrow(objref, CalcHome.class);
   } catch (Exception NamingException) {
     NamingException.printStackTrace();
   }
  }

  public void doGet (HttpServletRequest request, 
     HttpServletResponse response) 
     throws ServletException, IOException
  {
    String socsec = null;
    int multiplier = 0;
    double calc = 0.0;
    PrintWriter out;
    response.setContentType("text/html");
    String title = "EJB Example";
    out = response.getWriter();
    out.println("<HTML><HEAD><TITLE>");
    out.println(title);
    out.println("</TITLE></HEAD><BODY>");

    try{
    Calc theCalculation;

//Retrieve Bonus and Social Security Information
   String strMult = 
           request.getParameter("MULTIPLIER");
   Integer integerMult = new Integer(strMult);
   multiplier = integerMult.intValue();
   socsec = request.getParameter("SOCSEC");

//Calculate bonus
    double bonus = 100.00;
    theCalculation = homecalc.create();
    calc = theCalculation.calcBonus(multiplier, bonus);
    }catch(Exception CreateException){
       CreateException.printStackTrace();
    }

//Display Data
    out.println("<H1>Bonus Calculation</H1>");
    out.println("<P>Soc Sec: " + socsec + "<P>");
    out.println("<P>Multiplier: " + multiplier + "<P>");
    out.println("<P>Bonus Amount: " + calc + "<P>");
    out.println("</BODY></HTML>");
    out.close();
  }

  public void destroy() {
    System.out.println("Destroy");
  }
}
