import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;
import Beans.*;
import javax.ejb.*;
import java.util.*;

public class BonusServlet extends HttpServlet {

  CalcHome homecalc;
  BonusHome homebonus;
  Bonus theBonus, record;

  public void init(ServletConfig config) throws ServletException{
    try{
    	InitialContext ctx = new InitialContext();
	Object objref = ctx.lookup("bonus");
	Object objref2 = ctx.lookup("calcs");
	homebonus = (BonusHome)PortableRemoteObject.narrow(objref, BonusHome.class);
        homecalc = (CalcHome)PortableRemoteObject.narrow(objref2, CalcHome.class);
   } catch (Exception NamingException) {
	NamingException.printStackTrace();
   }
  }

  public void doGet (HttpServletRequest request, HttpServletResponse response
		    ) throws ServletException, IOException {
    String socsec = null, retsocsec = null;
    int multiplier = 0;
    double calc = 0.0, retbonus = 0.0;
    PrintWriter out;
    response.setContentType("text/html");
    String title = "EJB Example";
    out = response.getWriter();
    out.println("<HTML><HEAD><TITLE>");
    out.println(title);
    out.println("</TITLE></HEAD><BODY>");

    try {
    Calc theCalculation;
//Retrieve Bonus and Social Security Information
    String strMult = request.getParameter("MULTIPLIER");
    Integer integerMult = new Integer(strMult);
    multiplier = integerMult.intValue();
    socsec = request.getParameter("SOCSEC");

//Calculate bonus
      double bonus = 100.00;
      theCalculation = homecalc.create();
      calc = theCalculation.calcBonus(multiplier, bonus);
//Create row in table
      theBonus = homebonus.create(calc, socsec);
      record = homebonus.findByPrimaryKey(socsec);
//Display data
      out.println("<H1>Bonus Calculation</H1>");
      out.println("<P>Soc Sec passed in: " + theBonus.getSocSec() + "<P>");
      out.println("<P>Multiplier passed in: " + multiplier + "<P>");
      out.println("<P>Bonus Amount calculated: " + theBonus.getBonus() + "<P>");
      out.println("<P>Soc Sec retrieved: " + record.getSocSec() + "<P>");
      out.println("<P>Bonus Amount retrieved: " + record.getBonus() + "<P>");
      out.println("</BODY></HTML>");
//Catch duplicate key error
    } catch (javax.ejb.DuplicateKeyException e) {
      String message = e.getMessage();
      out.println("<H1>Bonus Calculation</H1>");
      out.println("<P>Soc Sec passed in: " + socsec + "<P>");
      out.println("<P>Multiplier passed in: " + multiplier + "<P>");
      out.println("<P>Bonus Amount calculated: " + calc + "<P>");
      out.println("<P>" + message + "<P>");
      out.println("</BODY></HTML>");
    } catch (Exception CreateException) {
      CreateException.printStackTrace();
    } 
  }

  public void destroy() {
    System.out.println("Destroy");
  }
}
