import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;
import java.rmi.RemoteException;
import Beans.*;
import javax.ejb.*;
import java.util.*;

public class BonusServlet extends HttpServlet {

  CalcHome homecalc;
  Bonus theBonus, record;

  public void init(ServletConfig config) throws ServletException{
    try{
    	InitialContext ctx = new InitialContext();
	Object objref = ctx.lookup("calcs");
        homecalc = (CalcHome)PortableRemoteObject.narrow(objref, CalcHome.class);
   } catch (Exception NamingException) {
	NamingException.printStackTrace();
   }
  }

  public void doGet (HttpServletRequest request, HttpServletResponse response
		    ) throws ServletException, IOException {
    String socsec = null, retsocsec = null;
    int multiplier = 0;
    double calc = 0.0;
    PrintWriter out;
    response.setContentType("text/html");
    String title = "EJB Example";
    out = response.getWriter();
    out.println("<HTML><HEAD><TITLE>");
    out.println(title);
    out.println("</TITLE></HEAD><BODY>");

//Retrieve Bonus and Social Security Information
    String strMult = request.getParameter("MULTIPLIER");
    Integer integerMult = new Integer(strMult);
    multiplier = integerMult.intValue();
    socsec = request.getParameter("SOCSEC");

    try {
      Calc theCalculation;
//Calculate bonus
      double bonus = 100.00;
      theCalculation = homecalc.create();
//Call session Bean
      theBonus = theCalculation.calcBonus(multiplier, bonus, socsec);
      record = theCalculation.getRecord(socsec);
//Display data returned by session Bean
      out.println("<H1>Bonus Calculation</H1>");
      out.println("<P>Soc Sec retrieved: " + record.getSocSec() + "<P>");
      out.println("<P>Bonus Amount retrieved: " + record.getBonus() + "<P>");
      out.println("</BODY></HTML>");
    } catch (javax.ejb.DuplicateKeyException e) {
      String message = e.getMessage();
      out.println("<H1>Bonus Calculation</H1>");
      out.println("<P>Soc Sec passed in: " + socsec + "<P>");
      out.println("<P>Multiplier passed in: " + multiplier + "<P>");
      out.println("<P>" + message + "<P>");
      out.println("</BODY></HTML>");
    } catch (Exception CreateException) {
      CreateException.printStackTrace();
    } 
  }
}
