import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class CookieServlet extends HttpServlet {
  private static final String SUM_KEY = "sum";
  public void doGet (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    int sum = 0;
    Cookie theCookie = null;
    Cookie cookies[] = request.getCookies();
    if (cookies != null) {
      for(int i=0, n=cookies.length; i < n; i++) {
        theCookie = cookies[i];
        if (theCookie.getName().equals(SUM_KEY)) {
          try {
            sum = Integer.parseInt(theCookie.getValue());
          } catch (NumberFormatException ignored) {
            sum = 0;
          }
          break;
        }
      }
    }

    try {
      String addendString = request.getParameter("Addend");
      int addend = Integer.parseInt (addendString);
      sum += addend;
      theCookie = new Cookie (SUM_KEY, Integer.toString(sum));
    } catch (NumberFormatException e) {
      if (theCookie == null) {
        theCookie = new Cookie (SUM_KEY, "0");
      }
    }
    theCookie.setMaxAge (10000);


// Generate Output
    response.setContentType("text/html");
// Save cookie
    response.addCookie(theCookie);
    PrintWriter out = response.getWriter();
    out.println("<html>" +
      "<head><title>Cookie Information</title></head>" +
      "<body bgcolor=\"#FFFFFF\">" +
      "<h1>Cookie Information</h1><table>");
    if (cookies != null) {
      for(int i=0, n=cookies.length; i < n; i++) {
        out.println ("<tr><td>" + cookies[i].getName() + "</td>");
        out.println ("<td>" + cookies[i].getValue() + "</td></tr>");
      }
    }
    out.println("</table></body></html>");
    out.close();
  }
}