import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class SessionServlet extends HttpServlet {
  private static final String SUM_KEY = "session.sum";
  private static final String ERROR_KEY = "session.errors";
  public void doGet (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    HttpSession session = request.getSession(true);
    Integer sum = (Integer) session.getValue(SUM_KEY);
    int ival = 0;
    if (sum != null) {
      ival = sum.intValue();
    }
    try {
      String addendString = request.getParameter("Addend");
      int addend = Integer.parseInt (addendString);
      sum = new Integer(ival + addend);
      session.putValue (SUM_KEY, sum);
    } catch (NumberFormatException e) {
      Integer errorCount = (Integer)session.getValue(ERROR_KEY);
      if (errorCount == null) {
        errorCount = new Integer(1);
      } else {
        errorCount = new Integer(errorCount.intValue()+1);
      }
      session.putValue (ERROR_KEY, errorCount);
    }

// Generate Output
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.println("<html>" +
      "<head><title>Session Information</title></head>" +
      "<body bgcolor=\"#FFFFFF\">" +
      "<h1>Session Information</h1><table>");
    out.println ("<tr><td>Identifier</td>");
    out.println ("<td>" + session.getId() + "</td></tr>");
    out.println ("<tr><td>Created</td>");
    out.println ("<td>" + new Date(session.getCreationTime()) + "</td></tr>");
    out.println ("<tr><td>Last Accessed</td>");
    out.println ("<td>" + new Date(session.getLastAccessedTime()) + "</td></tr>");
    out.println ("<tr><td>New Session?</td>");
    out.println ("<td>" + session.isNew() + "</td></tr>");
    String names[] = session.getValueNames();
    for (int i=0, n=names.length; i<n; i++) {
      out.println ("<tr><td>" + names[i] + "</td>");
      out.println ("<td>" + session.getValue (names[i]) + "</td></tr>");
    }
    out.println("</table></center></body></html>");
    out.close();
  }
}