/**** WelcomeForm.java ****/

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class WelcomeForm extends HttpServlet {
  public String getServletInfo() {
    return "WelcomeForm Servlet";
  }

  public void doGet(HttpServletRequest req,
      HttpServletResponse res)
      throws IOException, ServletException {
    res.setContentType("text/html");
    ServletOutputStream os = res.getOutputStream();
    String html = makeForm("Welcome Form");
    os.write(html.getBytes());
    os.flush();
  }

  private String makeForm(String title) {
    return 
      "<html><head><title>" + title +
      "</title></head><body>" +
      "<form METHOD=\"POST\">" +
      "<table border=3 cellpadding=3>" +
      "<tr>" +
      "<td>Name:</td>" +
      "<td><INPUT TYPE=\"text\" name=\"name\" size=30></td>" +
      "</tr>" +
      "<tr>" +
      "<td> </td>" +
      "<td><INPUT TYPE=\"submit\" name=\"submitButton\" value=\"SUBMIT\"></td>" +
      "</tr>" +
      "</table>" +
      "</form></body></html>";
  }

  public void doPost(HttpServletRequest req,
      HttpServletResponse res)
      throws ServletException, IOException {
    res.setContentType("text/html");
    ServletOutputStream os = res.getOutputStream();
    String html = makeHeader("Welcome Form");
    html += makeTable(req.getParameterValues("name")[0]);
    html += makeFooter();
    os.write(html.getBytes());
    os.flush();
  }

  private String makeHeader(String title) {
    return
      "<html>" +
      "<title>" + title + "</title>" +
      "<body>";
  }

  private String makeFooter() {
    return "</body>" + "</html>";
  }

  private String makeTable(String name) {
    return
      "<table border=3 cellpadding=3>" +
      "<tr>" +
      "<td>Welcome:</td>" +
      "<td>" + name + "</td>" +
      "</tr>" +
      "</table>";
  }
}
