import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
public class ClipApplication extends AppFrame {
  Button btn; TextArea ta;
  public ClipApplication() {
    super("ClipApplication");
    setSize(300, 300);
    btn = new Button("Get Clipboard Contents");
    add(btn, BorderLayout.SOUTH);
    ta = new TextArea();
    ta.setEditable(false);
    ta.setText("Why won't this work from a browser?");
    add(ta, BorderLayout.CENTER);
    btn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ta.setText(getClipboardData());
      }
    });
  }
  String getClipboardData() {
    String str = "Couldn't get system clipboard data.";
    Clipboard clipboard =
      Toolkit.getDefaultToolkit().getSystemClipboard();
    Transferable clipData =
      clipboard.getContents(clipboard);
    try {
      str = (String)
        (clipData.getTransferData(DataFlavor.stringFlavor));
    }
    catch (UnsupportedFlavorException ufe) {
      str = ufe.toString();
    }
    catch (Exception e) {
      str = e.toString();
    }
    return str;
  }
  public static void main(String[] args) {
    ClipApplication app = new ClipApplication();
    app.setVisible(true);
  }
}
